/* 
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

var map; //contenedor de capas y componentes
var points, heatmap;
var csvDataOverlay; //Grupos de capas para datos csv
var vectorLayer, iconFeature, popup;
var singleclickFunction;
var container, content, closer; // contenedores (divs) para el popup (mapa de puntos)
var geoserverHost;

$(function () {

    //Divisiones para popup (configuradas con estilos)
    container = document.getElementById('popup');
    content = document.getElementById('popup-content');
    closer = document.getElementById('popup-closer');

    geoserverHost = 'http://' + location.host + '/geoserver/sigeodepsig/wms';

    var bmapsRoads = new ol.layer.Tile({
        opacity: 0.8,
        title: 'BingMaps Roads',
        source: new ol.source.BingMaps({
            key: 'AnyGyd4GaAzToU0sDaA0NaXDD88yChcUh8ySoNc32_ddxkrxkl9K5SIATkA8EpMn',
            imagerySet: 'Road'
        }),
        visible: false
    });
    /*Creacion capa base Bing Maps Aerial*/
    var bmapsAerial = new ol.layer.Tile({
        opacity: 0.8,
        title: 'BingMaps Aerial',
        source: new ol.source.BingMaps({
            key: 'AnyGyd4GaAzToU0sDaA0NaXDD88yChcUh8ySoNc32_ddxkrxkl9K5SIATkA8EpMn',
            imagerySet: 'AerialWithLabels'}),
        visible: true
    });
    /*Creacion capa base de OSM*/
    var osmLayer = new ol.layer.Tile({
        opacity: 0.8,
        title: 'OpenStreetMaps',
        source: new ol.source.OSM(),
        visible: false
    });


    /*Creacion capa base Comunas*/
    var communes = new ol.layer.Image({
        title: 'Comunas',
        source: new ol.source.ImageWMS({
            ratio: 1,
            url: geoserverHost,
            params: {'FORMAT': 'image/png',
                'VERSION': '1.1.1',
                LAYERS: 'sigeodepsig:communes',
                STYLES: '',
                env: 'opacity:0.4'
            }
        }),
        visible: false
    });

    /*Creacion capa base Barrios*/
    var neighborhoods = new ol.layer.Image({
        title: 'Barrios',
        source: new ol.source.ImageWMS({
            ratio: 1,
            url: geoserverHost,
            params: {'FORMAT': 'image/png',
                'VERSION': '1.1.1',
                LAYERS: 'sigeodepsig:neighborhoods',
                STYLES: '',
                env: 'opacity:0.4'
            }
        }),
        visible: false
    });

    /*Creacion capa base Vias*/
    var roads = new ol.layer.Image({
        title: 'Vias',
        source: new ol.source.ImageWMS({
            ratio: 1,
            url: geoserverHost,
            params: {'FORMAT': 'image/png',
                'VERSION': '1.1.1',
                LAYERS: 'sigeodepsig:roads',
                STYLES: '',
                env: 'opacity:0.4'
            }
        }),
        visible: false
    });

    /**
     * GRUPOS PARA LAYERSWITCHER
     * @type ol.layer.Group
     */
    var baseMaps = new ol.layer.Group({
        title: 'Mapas Base',
        layers: [osmLayer, bmapsRoads, bmapsAerial]
    });

    var baseLayers = new ol.layer.Group({
        title: 'Capas Base',
        layers: [neighborhoods, communes, roads]
    });



    /**
     * MAPA
     * @type ol.Map
     */
    map = new ol.Map({
        target: 'map', // The DOM element that will contains the map

        controls: ol.control.defaults({
            attributionOptions: ({
                collapsible: false
            })
        }).extend([
            new ol.control.ZoomToExtent({
                extent: [
                    -8605605, 137132,
                    -8599605, 132374
                ]
            }),
            new ol.control.ScaleLine(),
            //new ol.control.FullScreen(),
            new ol.control.MousePosition({
                coordinateFormat: ol.coordinate.createStringXY(4),
                projection: 'EPSG:3857'
            })
        ]),
        renderer: 'canvas', // Force the renderer to be used
        layers: [baseMaps, baseLayers],
        // Create a view centered on the specified location and zoom level
        view: new ol.View({
            center: [-8602509.5692, 134983.3435],
            zoom: 14,
            maxZoom: 18,
            minZoom: 14
        })
    });

    /**
     * ADICION DEL CONTROL LAYERSWITCHER
     * @type ol.control.LayerSwitcher
     */
    var layerSwitcher = new ol.control.LayerSwitcher();
    map.addControl(layerSwitcher);

    setInterval(function () {
        map.updateSize();
    }, 2);

    /*
     * Adicion de dialogo (popup)
     */
    closer.onclick = function () {
        container.style.display = 'none';
        closer.blur();
        return false;
    };
    popup = new ol.Overlay({
        element: container
    });

    map.addOverlay(popup);


});

function loadCSVMaps() {

    map.removeLayer(vectorLayer);
    map.removeLayer(csvDataOverlay);

    map.un('singleclick', singleclickFunction);

    container.style.display = 'none';
    closer.blur();

    var singleclickFunction;

    var sessionId = $('#form\\:txtSessionId').val();
    var csvFileName = $('#form\\:txtCSVFileName').val();
    var clustering = $('#form\\:txtClusteringValues').val();
    var clusteringAttribute = $('#form\\:txtClusteringAttributeValue').val();
    var processedTuples = parseInt($('#form\\:txtProcessedTuples').val());

    var csvMaps = [];

    if (processedTuples > 0) {
        if (clustering !== 'undefined') {
            var clusteringValues = clustering.split(",");
            for (var i = 0; i < clusteringValues.length - 1; i++) {
                var color = randomColor({luminosity: 'dark', count: 1});
                csvMaps.push(
                        new ol.layer.Image({
                            title: clusteringValues[i],
                            source: new ol.source.ImageWMS({
                                ratio: 1,
                                url: 'http://' + location.host + '/geoserver/sigeodepsig/wms',
                                params: {'FORMAT': 'image/png',
                                    'VERSION': '1.1.1',
                                    LAYERS: 'sigeodepsig:csv_data_clustering',
                                    STYLES: '',
                                    viewparams: 'id:' + sessionId + ';value:' + removeDiacritics(clusteringValues[i]).replace(/[^\w]/gi, ''),
                                    env: 'color:' + color.toString().replace(/[^\w]/gi, '')
                                }
                            }),
                            visible: true
                        })
                        );
            }

            csvDataOverlay = new ol.layer.Group({
                title: 'Agrupados por: ' + clusteringAttribute,
                layers: csvMaps
            });

            singleclickFunction = function (evt) { //para clustering
                var view = map.getView();
                var viewResolution = view.getResolution();
                var properties = '';

                for (var i = 0; i < csvMaps.length; i++) {
                    if (csvMaps[i].getVisible()) {
                        container.style.display = 'none';
                        var source = csvMaps[i].getSource();
                        var url = source.getGetFeatureInfoUrl(
                                evt.coordinate,
                                viewResolution,
                                view.getProjection(),
                                {
                                    'INFO_FORMAT': 'application/json',
                                    'FEATURE_COUNT': 1
                                }
                        );
                        if (url) {
                            $.getJSON(url, function (data) {
                                if (data.features.length > 0) {
                                    properties = data.features[0].properties.properties;
                                    popup.setPosition(evt.coordinate);

                                    var json = JSON.parse(properties);
                                    var msj = "<div><div style=\"text-align:center;\">\n"
                                            + "<b>Informacion</b>\n"
                                            + "</div><br>";
                                    for (var key in json) {
                                        msj = msj + '<b>' + key + ':</b> ' + json[key] + '<br>';
                                    }
                                    msj = msj + "</div>";

                                    content.innerHTML = msj;
                                    container.style.display = 'block';
                                }
                            });
                        }
                    }

                }
            };

        } else {
            var csvDataLayer = new ol.layer.Image({
                title: csvFileName,
                source: new ol.source.ImageWMS({
                    ratio: 1,
                    url: 'http://' + location.host + '/geoserver/sigeodepsig/wms',
                    params: {
                        'FORMAT': 'image/png',
                        'VERSION': '1.1.1',
                        LAYERS: 'sigeodepsig:csv_data_no_clustering',
                        STYLES: '',
                        viewparams: 'id:' + sessionId,
                    }
                }),
                visible: true
            });

            csvDataOverlay = new ol.layer.Group({
                title: 'Datos CSV',
                layers: [csvDataLayer]
            });

            singleclickFunction = function (evt) { //no clustering
                var view = map.getView();
                var viewResolution = view.getResolution();
                var source = csvDataLayer.getSource();
                var properties = '';
                var url = source.getGetFeatureInfoUrl(
                        evt.coordinate,
                        viewResolution,
                        view.getProjection(),
                        {
                            'INFO_FORMAT': 'application/json',
                            'FEATURE_COUNT': 1
                        }
                );
                if (url) {
                    $.getJSON(url, function (data) {
                        if (data.features.length > 0) {
                            properties = data.features[0].properties.properties;
                            popup.setPosition(evt.coordinate);

                            var json = JSON.parse(properties);
                            var msj = "<div><div style=\"text-align:center;\">\n"
                                    + "<b>Informacion</b>\n"
                                    + "</div><br>";
                            for (var key in json) {
                                msj = msj + '<b>' + key + ':</b> ' + json[key] + '<br>';
                            }
                            msj = msj + "</div>";

                            content.innerHTML = msj;
                            container.style.display = 'block';
                        }
                    });
                }
            };

        }

        map.on('singleclick', singleclickFunction);
        map.addLayer(csvDataOverlay);
    }
}
